#include <stdio.h>
#include "swinclude.h"
#include "swglobals.h"

read_init_file()
	{
	int i;
	printf("Reading init file\n");
	if((i= open(INITFILE,0)) < 0 || read(i,&t,sizeof(t)) != sizeof(t))
		{
		printf("Trouble reading init file %s\n",INITFILE);
		exit(1);
		}
	close(i);
	}

read_ship_files(argc, argv)
int argc;
char **argv;
	{
	int infile, i, shipnow;
	char shipfilename[128];
	FILE *f;

/* try to find his .orbitrc and read it if it's there */
	sprintf(shipfilename,"%s/.orbitrc",getenv("HOME"));
	if(f= fopen(shipfilename,"r"))
		if(readmenu(f))
			{
			printf("Trouble reading %s\n",shipfilename);
			exit(1);
			};

	/* read in any ship rasters needed */
	printf("Reading ship files\n");
	switch(argc) {

		case 1:	/* no arguments; enlighten the user */
			printf("How many players? ");
			fflush(stdout);
			if (scanf("%hd",&ships) != 1) exit(0);
			else	shipmenu();
			break;

		case 2: /* one argument; first try it as a number */
			if(sscanf(argv[1],"%hd",&ships) == 1)
				{
				shipmenu();
				break;
				}
			/* note the fall through to the next case allows the case of
				one ship to "work" (it's even useful if Twiddletime is big */

		default: /* assume they're all ships until otherwise shown */
			ships = argc-1;
			shipnow= -1;	/* this points to the current slot in ship_ras */
			for(i=1; i < argc; ++i)
				{
				if(argv[i][0] == '-')	/* ahah! an option */
					{
					++i; --ships;
					switch(argv[i-1][1]) { /* what's the next character ? */

					case 'O':	/* an options file overriding the .orbitrc */
						if(!(f= fopen(argv[i],"r")))
							{
							printf("Trouble opening option file %s\n", argv[i]);
							exit(1);
							}
						if(!readmenu(f))
							{
							++i; --ships;
							close(f);
							}
						else
							{
							printf("Trouble reading option file %s\n", argv[i]);
							exit(1);
							};
						break;
					default:	/* unrecognized option */
						printf("Unrecognized option %c\n",argv[i][1]);
						exit(1);
						};
					}
				else	/* rashly assume it's a ship file */
					{
					if(++shipnow >= MAXSHIPS)
						{
						printf("Too many ships; sorry!\n");
						exit(1);
						}
				/* don't reallocate if storage already exists */
					if(!ship_ras[shipnow])
						ship_ras[shipnow]=
							(sframe *) malloc(ANGLES * sizeof(sframe));

					sprintf(shipfilename,"%s/%s",SHIPDIRECTORY,argv[i]);

					/* First try the name */

					infile = open (argv[i], 0);

					/* Next, try the directory */

					if (infile < 0) infile = open(shipfilename, 0);

					if (infile < 0)
						{
						printf("Could not find %s\n", argv[i]);
						exit(1);
						}

					if(read(infile, ship_ras[shipnow], ANGLES*sizeof(sframe))
						!= ANGLES*sizeof(sframe))
						{
						printf("Trouble reading %s\n",argv[i]);
						exit(1);
						}
					close(infile);
					}
				}
			}
	/* 'ships' should be valid here, finally! */
		smax= &s[ships];
		bombs= BOMBSPERSHIP * ships;
		bmax= &b[bombs];
	}
