#include "swinclude.h"
#include "swglobals.h"
#include "udvals.h"
#include <stdio.h>

/* declarations for control set */
enum keyaction
	{left_up,left_down,right_up,right_down,
	 thrust_up,thrust_down,shoot_up,shoot_down};

/* an entry in the keymap table */
struct k_m
	{struct mass *who;
	 enum keyaction what;};

/* the keymap table */
struct k_m Key[256];

/* names for all the strange keys */
char *odd_names[]={
	"CAPSLOCK", "CAPS", "LSHIFT", "RSHIFT", "CTRL", "NOSCROLL", "SETUP",
	"PF1", "PF2", "PF3", "PF4", "BREAK", "UPARROW", "DOWNARROW",
	"LEFTARROW", "RIGHTARROW", 0};
char *pad_names[]={
	"PAD0", "PAD1", "PAD2", "PAD3", "PAD4",
	"PAD5", "PAD6", "PAD7", "PAD8", "PAD9",
	"","", "PAD,", "PAD-", "PAD.", "PADENTER", 0};

do_controls()
	{
	register unsigned char *udptr;
	register struct mass *ship;

	ud_read(udkeybuf);
	if(*udkeybuf)
		for(udptr=udkeybuf;*udptr;++udptr)
			if(ship= Key[*udptr].who)
				switch(Key[*udptr].what)
					{
					case left_up:
						if(ship->ton)
							ship->ton= 0;
						else	ship->ton= -Turnrate;
						break;
					case left_down:
						if(ship->ton)
							ship->ton= 0;
						else	ship->ton= Turnrate;
						break;
					case right_up:
						if(ship->ton)
							ship->ton= 0;
						else	ship->ton= Turnrate;
						break;
					case right_down:
						if(ship->ton)
							ship->ton= 0;
						else	ship->ton= -Turnrate;
						break;
					case thrust_up:
						ship->engineon=0;
						break;
					case thrust_down:
						ship->engineon=1;
						break;
					case shoot_up:
						ship->shooting= 0;
						break;
					case shoot_down:
						ship->shooting=1;
						if(!ship->cooling)
							{
							ship->cooling= 1;
							ship->clock= 1;
							}
						break;
					default:
						printf("KM ERROR: %d\n",Key[*udptr].what);
						break;
					}
	}

map_keys(pnum,keystring) int pnum; unsigned char *keystring;
	{register struct mass *Who;
	 register struct k_m *key;
	 register int i;

	 Who= &s[pnum];
	 /* first clear out any old definitions for this player */
	 for(i=0,key=Key; i<256; ++i,++key)
		if(key->who == Who)
			key->who = 0;

	/* then install new definitions */
	for(i=(int)left_up; *keystring; ++keystring,++i)
		{
		Key[U(*keystring)].who= Who;
		Key[U(*keystring)].what= (enum keyaction) i;
		Key[*keystring].who= Who;
		Key[*keystring].what= (enum keyaction) ++i;
		}
	/* that's it! */
	}

keymap_init()
	{
	map_keys(0,"zxcv");
	map_keys(1,"m,./");
	map_keys(2,"OLM\031");
	}

read_keymap(f1) FILE *f1;
	{
	char keyname[20], keystring[5];
	register char **str;
	register int i;
	int shipno;
	struct mass *ship;

	if(fscanf(f1,"%d",&shipno)!=1) return(1);
	if(shipno <1 || shipno >4) return(1);
	ship= &s[--shipno];
	for(i=0; i < 4; ++i)
		{
		if(fscanf(f1,"%*[^|]|%[^|]",keyname)!=1)
			return(1);
		if(keyname[1])	/* it's longer than one character */
			{
			for(str= odd_names; *str; ++str)
				if(!strcmp(*str,keyname))
					{
					keystring[i]= str-odd_names +CPLK;
					break;
					}
			if(*str) continue;
			for(str= pad_names; *str; ++str)
				if(!strcmp(*str,keyname))
					{
					keystring[i]= str-pad_names + PAD0;
					break;
					}
			if(*str) continue;
			fprintf(stderr,"|%s| isn't a key name!\n",keyname);
			return(1);
			}
		else
			keystring[i]= keyname[0];
		}
	fscanf(f1,"%*[^\n]%*c");	/* throw away the rest of the line */
	keystring[4]= 0;
	map_keys(shipno,keystring);
	return(0);
	}

unsigned char get_a_key()
	{
	unsigned char buf[91];

	do
		ud_read(buf);
	while(!buf[0] || buf[0] > 127);
	return(buf[0]);
	}

key_input()	/* accept a keymap from the keyboard and store it */
	{
	struct mass *ship;
	int i,keycode;
	struct k_m *key;
	static char *cont_names[]=
		{"left","right","thrust","shoot"};

	do
		{
		do
			printf("Ship number:");
		while(scanf("%d",&i)!=1);
		if(i<1 || i>4)
			printf("Number must be in range 1-4\n");
		}
	while(i<1 || i>4);
	ship= &s[i-1];
	/* first clear out any old definitions for this player */
	for(i=0,key=Key; i<256; ++i,++key)
		if(key->who == ship)
			key->who = 0;
	ud_init();
	for(i=0; i<4; ++i)
		{
		printf("Press key for %s: ",cont_names[i]);
		keycode= get_a_key();
		Key[U(keycode)].who= ship;
		Key[U(keycode)].what= (enum keyaction) (i<<1);
		Key[keycode].who= ship;
		Key[keycode].what= (enum keyaction) ((i<<1)+1);
		printf("Got it\r\n");
		}
	ud_quit();
	key_dump(ship,stdout);
	printf("If you don't like these, try again\n");
	}

key_dump(ship,file) struct mass *ship; FILE *file;
	{
	char keys[4];
	register struct k_m *key;
	register int i;

	for(i=0; i<4; ++i) keys[i]= 0;

	for(i=0,key= Key; i<128; ++i,++key)
		if(key->who == ship)
			keys[(int)(key->what) >>1]= i;
	if(keys[0] && keys[1] && keys[2] && keys[3])
		{
		fprintf(file,"KeyMap %d |",ship-s+1);
		for(i=0; i<4; ++i)
			if(keys[i] >= CPLK && keys[i] <= ARRI)
				fprintf(file,"%s|",odd_names[keys[i]-CPLK]);
			else if(keys[i] >= PAD0 && keys[i] <= PADe)
				fprintf(file,"%s|",pad_names[keys[i]-PAD0]);
			else
				fprintf(file,"%c|",keys[i]);
		putc('\n',file);
		}
	else
		printf(stderr,"Bad keymap for ship %d\n",ship-s);
	}
