#include <legsdef.h>
#include "swinclude.h"
#include "swglobals.h"

struct mass 	s[MAXSHIPS],b[MAXBOMBS],*smax,*bmax;
struct mass 	THESUN = {0,0};         /* useful for sun collisions */
sframe			*ship_ras[MAXSHIPS];    /* array of pointers to rasters */
unsigned char udkeybuf[90];		/* buffer for up-down keycode software */


/* CONVENTION:  First leter cap == tweakable parameter;
		All caps        == constant */
/* tweakable float parameters */
float   G		= GRAVITY,
		Ethrust		= ETHRUST,
		Bdelv		= BDELV,
		Bounce		= BOUNCE,
		Initv		= INITV,
		ShipMass	= SHIPMASS,
		Elasticity	= ELASTICITY,
		ShipBounce,
		BombBounce;
/* tweakable int parameters */
int     Sdietime  	= SDIETIME,
		Scooltime 	= SCOOLTIME,
		Blifetime 	= BLIFETIME,
		Bdietime  	= BDIETIME,
		Twiddletime	= TWIDDLETIME;
/* tweakable char parameters */
unsigned char	Turnrate = TURNRATE;


/* clock that counts time from death of next-to-last ship to round end */
short twiddle;

/* counter that keeps track of currently living ships */
short live_ships;

short ships, bombs;

/* Menu added 3-12-83 CWS */
/* Code reorganized a little 3-17-83 CWS */
/* Code reorganized yet again 4-8-83 JRB */

menuentry	swmenu[] = {
	{(char *)&G,         "Gravity",			FLOAT},
	{(char *)&Ethrust,   "Thrust",			FLOAT},
	{(char *)&Turnrate,  "TurnSpeed",		CHAR},
	{(char *)&Bdelv,     "SpeedBomb",		FLOAT},
	{(char *)&Scooltime, "RateBomb",		INT},
	{(char *)&Blifetime, "LifeBomb",		INT},
	{(char *)&Bdietime,  "DieTimeBomb",  	INT},
	{(char *)&Sdietime,  "ShipDieTime",		INT},
	{(char *)&Twiddletime, "SurvivalTime",  INT},
	{(char *)&Elasticity,"Elasticity",		FLOAT},
	{(char *)&ShipMass,	 "MassShip",		FLOAT},
	{"",				"KeyMap",			KEYMAP},
	{"",				"Display",			DISPLAY},
	{"<parameterfile>",	"Dump",				DUMP},
	{"<parameterfile>",	"Load",				LOAD},
	{0,0,EMPTY}
};

main(argc,argv) int argc; char **argv;
	{

	if(GXfind()) exit(1);    /* &^%$#@! graphics board init! */
	read_init_file();
	read_ship_files(argc, argv);
	
	keymap_init(); /* map the initial set of keys */
	check_menu();
	ud_init();    /* start up the up_down keyboard software */

	/* finally; the main game loop! */
	for(;;)
		{
		ship_init();
		bomb_init();
		ras_clear();  
		twiddle= Twiddletime;

		while(live_ships > 1 || --twiddle)
			{
		do_sun();
		do_ships();
		do_bombs();
		do_controls();
		}
	end_round();
	}
	}
