#include <stdio.h>
#include "swinclude.h"
#include "swglobals.h"
#define UPCASE 040

menuentry swmenu[];

readmenu(f)
FILE *f;
	{
	char word[64];	/* buffer for current word */
	int lose;

		lose= 0;
		while((fscanf(f,"%s",word)==1) && !lose)
			lose= changemenu(word,f);
		if(!lose) fixtables();
		return(lose);
	}


writemenu()
	{
	menuentry *m;

	for(m= swmenu; m->type; ++m)
		{
		switch (m->type) {
			case CHAR:
			   printf("%s\t%d\n", m->name, *(char *)(m->item)); break;
			case INT:
			   printf("%s\t%d\n", m->name, *(int *)(m->item)); break;
			case HALF:
			   printf("%s\t%d\n", m->name, *(short *)(m->item)); break;
			case FLOAT: 
			   printf("%s\t%f\n", m->name, *(float *)(m->item));break;
			case DOUBLE:
			   printf("%s\t%f\n", m->name, *(double *)(m->item));break;
			case LOAD: case DUMP: case DISPLAY: case KEYMAP:
				printf("%s\t%s\n",m->name,m->item); break;
			}}}

dumpmenu(f)
FILE *f;
	{
	menuentry *m;
	int i;

	for(m= swmenu; m->type; ++m)
		{
		switch (m->type) {
			case CHAR:
			   fprintf(f,"%s %d\n", m->name, *(char *)(m->item)); break;
			case INT:
			   fprintf(f,"%s %d\n", m->name, *(int *)(m->item)); break;
			case HALF:
			   fprintf(f,"%s %d\n", m->name, *(short *)(m->item)); break;
			case FLOAT: 
			   fprintf(f,"%s %f\n", m->name, *(float *)(m->item)); break;
			case DOUBLE:
			   fprintf(f,"%s %f\n", m->name, *(double *)(m->item)); break;
			case KEYMAP:	/* yet to be written */
				for(i=0; i<ships; ++i)
					key_dump(&s[i],f);
				break;
		/* don't do anything for DUMP, LOAD, and DISPLAY here */
			}}}

changemenu(w, f)
char *w;
FILE *f;
	{
	menuentry *m;
	int temp, i, j, ftot;
	FILE *ft;
	char filename[128], flags[128], *fp;

	for(i=0;i<128;flags[i++]=0);
	for(i=0;i<strlen(w);i++) {
		for(m=swmenu, ftot=0, j=0;m->type;m++, j++) {
			if(flags[j]) continue;
			else if(((m->name[i])|UPCASE)!=((w[i])|UPCASE)
				|| !m->name[i])
				flags[j]=1;
			else ftot++;
		}
		if(ftot==0 || ftot==1)
			break;
	}
	if(ftot>1) {
		printf("Ambiguous name %s.\n", w);
		return(0);
	}

	else if(ftot==0) {
		printf("Bad name %s.\n", w);
		return(0);
	}

	else if(ftot==1)
/* { */	for(m= swmenu, fp=flags; m->type; ++m)
		if (!*fp++) {
			switch (m->type) {
				case CHAR:	if(fscanf(f,"%d", &temp) != 1)
							break;
						*(char *)(m->item) = temp;
						return(0);
				case INT:	if(fscanf(f,"%d", m->item)!=1)
							break;
						return(0);
				case HALF:	if(fscanf(f,"%hd", m->item)!=1)
							break;
						return(0);
				case FLOAT:	if(fscanf(f,"%f", m->item)!=1)
							break;
						return(0);
				case DOUBLE:	if(fscanf(f,"%lf", m->item)!=1)
							break;
						return(0);
				case DUMP:	if(fscanf(f,"%s",filename)!=1)
							break;
						if(!(ft= fopen(filename,"w")))
							break;
						dumpmenu(ft);
						fclose(ft);
						return(0);
				case LOAD:	if(fscanf(f,"%s",filename)!=1)
							break;
						if(!(ft= fopen(filename,"r")))
							break;
						if(readmenu(ft)) break;
						fclose(ft);
						return(0);
				case DISPLAY:
						dumpmenu(stdout);
						return(0);
				case KEYMAP:	/* yet to be written */
						if(f==stdin)
							key_input();
						else
							if(read_keymap(f)) break;
						return(0);
			}
			printf("Menu error!\n");
			break;
		}
/* } */
	printf("Huh (%s)?", w);
	return(1);
}

domenu(m)
menuentry *m;
	{
	writemenu();
	readmenu(stdin);
	}

strmatch(s1,s2)		/* case-insensitive string comparer */
char *s1,*s2;
	{
	while(*s1 && *s2)
		if((*s1++ | UPCASE) != (*s2++ | UPCASE))
			return(0);
	return(!(*s1 | *s2));
	}
