.TH ORBIT 6 
.SH NAME
orbit \- Spacewar on the Sun
.SH SYNOPSIS
.B
orbit <players>
.PP
.B
orbit <ship1name> ... [-O <optionfile>]
.SH DESCRIPTION
The classic game of interplanetary death and destruction.
Mostly written in C; an assembler package does fast single-precision
floating-point for orbital calculations and collision detection.
.PP
Most of the game's basic parameters are changeable;
parameter sets can be saved and reloaded from option files.
If the file .orbitrc exists in your
.B
$(HOME)
directory,
.B
orbit
will try to read it in as an option file.
.sp
.TS
expand;
l c l
l n lw(35).
Parameter	Initial	Value	Meaning
Gravity	-3000.0	T{
Pull of the sun.
T}
Thrust	0.1	T{
Power of each ship's engine.
T}
TurnSpeed	5	T{
Number of 256'ths of a full circle a ship turns in one tick.
T}
RateBomb	20	T{
Minimum time between shots.
T}
SpeedBomb	3.0	T{
Speed increment a bomb gets when fired.
T}
LifeTimeBomb	512	T{
Time a bomb lives after firing.
T}
DieTimeBomb	20	T{
Time it takes a bomb to die after exploding.
T}
ShipDieTime	32	T{
Time it takes a ship to die after being destroyed.
T}
Elasticity	0.9	T{
Fraction of energy conserved in rebound after any collision.
T}
MassShip	5.0	T{
Mass of a ship for collision purposes (in bomb units).
T}
SurvivalTime	64	T{
Time last ship must survive to score survival points.
T}
.TE
.sp
.PP
All times are in ticks; a tick is the amount of time between iterations
of the orbit calculator (there are about 20-30 ticks/second depending
on how many ships are playing).
All distances are in pixels (i.e., BombSpeed's units are pixels/tick).
To change parameters, answer
.I y
to the 'Change parameters?' prompt, then enter parameter-name and value
pairs. Stop changing with control-D.
Parameter names can be abbreviated to the shortest unique prefix
(this is the reason for the inconsistency in parameter naming).
.PP
Players can design their own ships (see
.B
prepship(6)
), or use one from the library in /usr/games/lib/orbit.
.PP
.B
orbit
uses the up-down keyboard on the console for controls.
Each ship is controlled by four keys:
.sp
.TS
l l l l l
l l l
c c c c c.
Ship	Left	Right	Thrust	Shoot
	(ccw)	(cw)
1	z	x	c	v
2	m	,	.	?
3	ENTER	,	-	PF4
.TE
.sp
.PP
Ship 3's controls are all on the keypad.
.PP
Scoring: the firer of a bomb scores one point if it hits another ship
and destroys it.  He loses a point if he shoots himself. The last
surviving player (if any) in a given round also gets a point.
The score display flags the round scores of the last survivor with 'S'
and anyone who shoots himself with '*'.
.SH FILES
/usr/games/lib/orbit/* - ship files.
.br
/usr/games/lib/sw.tables
.br
$(HOME)/.orbitrc - personal option file.
.SH SEE ALSO
prepship(6)
.SH AUTHOR
Bob Bane
.SH BUGS
Has been known to crash the Sun, forcing a reboot.
Uses a /dev/kmem kludge to read the up-down keyboard buffer;
when this happens to get interrupted in the middle of reading
the 4 bytes of a pointer, all hell breaks loose.
