#include <legsdef.h>
#include "swinclude.h"
#define FROWMIN	1
#define FCOLMIN 4
#define FROWMAX	30
#define SROWMIN (1024-44)
#define SCOLMIN 0
#define FROWDELTA	2
#define FCOLDELTA	20
#define SROWDELTA	(FROWDELTA * 22)
#define SCOLDELTA	(FCOLDELTA * 12)
#define PROMPTROW	31
#define PROMPTCOL	1

short ships;
sframe *ship_ras[MAXSHIPS];

shipmenu()	/* plots one frame from each entry in the SHIPDIRECTORY directory */
	{int p1[2],		/* pipe for comunication with 'ls' process */
		srow,scol,	/* where the next ship frame goes */
		frow,fcol,	/* where the next name line goes */
		shipfile,	/* file descriptor for ship files */
		shipcount,	/* counts ships */
		ok;			/* flag for final prompt loop */

	char namebuf[128],	/* names are scanned into here from 'ls' */
		dirbuf[128];	/* and turned into path names in here */

	sframe shipbox;		/* buffer for current ship frame */

	FILE *f;			/* stream descriptor for 'ls' process */

	pipe(p1);	/* get set to talk to 'ls' process */
	if(fork())	/* this is the master process */
		{
	/* first get the master raster arrays ready */
		for(shipcount=0; shipcount < ships; ++shipcount)
			ship_ras[shipcount]= (sframe *)malloc(ANGLES * sizeof(sframe));

		close(p1[1]);		/* we'll be reading from this one */
		f= fdopen(p1[0],"r");	/* using streams for simplicity */

	/* initialize all the coordinates */
		srow= SROWMIN; scol= SCOLMIN;
		frow= FROWMIN; fcol= FCOLMIN;

	/* may as well erase the screen here */
		ras_clear();

	/* then loop down the directory */
		while(fscanf(f,"%s",namebuf)==1)
			{
		/* suck in the filename and open it */
			sprintf(dirbuf,"%s/%s",SHIPDIRECTORY,namebuf);
			shipfile= open(dirbuf,0);
		/* read the first vertical frame of the ship */
			lseek(shipfile,64*sizeof(sframe),0);
			read(shipfile,shipbox,sizeof(shipbox));
			close(shipfile);
		/* print the ship and assorted labeling information */
			ras_put(scol,srow,31,31,shipbox,GXcopy);
			printf("[%d;%dH% %s",frow,fcol,namebuf);

		/* move all the coordinates to their next positions */
			srow -= SROWDELTA;
			if((frow += FROWDELTA) >FROWMAX)
				{
				frow= FROWMIN;
				fcol += FCOLDELTA;
				srow = SROWMIN;
				scol += SCOLDELTA;
				}
			}
	/* keep prompting until he gets it right */
		ok= 0;
		do
			{
			ok= 1;
		/* now prompt for ship names and suck them in */
			printf("[%d;%dHEnter the names of the %d ships you want:\n[K",
				PROMPTROW,PROMPTCOL,ships);
			for(shipcount= 0;shipcount < ships; ++shipcount)
				{
				namebuf[0]= 0;
				scanf("%s",namebuf);
				sprintf(dirbuf,"%s/%s",SHIPDIRECTORY,namebuf);
				if((shipfile= open(dirbuf,0)) <0
				||	read(shipfile, ship_ras[shipcount],ANGLES * sizeof(sframe))
					!= ANGLES * sizeof(sframe))
					{
					printf("Trouble with %s",namebuf);
					while(getchar() != '\n');
					sleep(2);
					ok= 0;
					break;
					}
				}
			}
		while (!ok);
		}

	else	/* the slave 'ls' process */
		{
		close(p1[0]);	/* this one won't be reading anything */
		dup2(p1[1],1);	/* but it will be writing to the pipe */
		execl("/bin/ls","ls",SHIPDIRECTORY,0);
		}
	}
