#include <legsdef.h>
#include "swinclude.h"
#include "swglobals.h"

do_sun()
	{/* current frame of sun movie */
	static unsigned char sunframe= 0,sundirection=1;
	/* refresh the "sun" */
	ras_put(SXOFF,SYOFF,31,31,t.sun[sunframe],GXcopy);

	/* make the sun go in and out and in and out ... */
	if(!(sunframe += sundirection))
	sundirection= (sundirection==1 ? 0xff:1);
	}

do_ships()
	{
	register struct mass *ship,*ship2;
	register int oldx, oldy, shipbit, notshipbit;

	/* rip down the ship list */
	for(ship= s, shipbit= 1, notshipbit= ~1;
		ship < smax;
		++ship, shipbit <<= 1,(notshipbit <<= 1),++notshipbit)
		{
	/* Save ship's location */
		oldx= ship->scix;
		oldy= ship->sciy;
		orbit(ship);    /* this does all orbit calcualtions */
		ship->scix = ship->ix + SXOFF;
		ship->sciy = ship->iy + SYOFF;

	/* anything that gets REALLY close to the sun dies at once */
		if(bump(ship,&THESUN,MINALT)) wound(ship,1);

		if(ship->alive)
			{
			/* Allow for thrust */
			if(ship->ton)
			{
				ship->theta += ship->ton;
				ship->xt=t.thrust[(ship->theta+64)&255];
				ship->yt= t.thrust[ship->theta];
			}
		/* Move the ship */
			parmove(oldx,        oldy,
				ship->scix,  ship->sciy,
				31,          31,
				(ship->u.s.frame)[ship->theta]);

		/* check for ship-ship collisions here */
			{register int nots2bit;

				for(ship2= ship+1, nots2bit= (notshipbit << 1)+1;
					ship2 < smax;
					++ship2,(nots2bit <<=1),++nots2bit)
					if(ship2->alive)
						if(bump(ship,ship2,30))
							{
							if(!(shipbit & (ship2->u.b.shipset)))
								ss_collide(ship, ship2);
							}
						else
							{
							ship2->u.b.shipset &= notshipbit;
							ship->u.b.shipset &= nots2bit;
							};
			}

			if(!(ship->well))
				do_derelict(ship);
			else
				{
			/* Make flame */
				if(ship->engineon)
					ras_put(ship->scix,   ship->sciy,
						31,           31,
						t.flame[ship->theta],
						GXxor);
			/* Fire! */
				if(ship->cooling && !--(ship->clock))
					if(ship->shooting)
						do_shoot(ship);
					else ship->cooling= 0;

			/* check for ship-sun collisions here */
			/* if you touch the sun, you die (almost) at once! */

				if(bump(ship,&THESUN,30))
					{
/* the below code breaks the compiler: its replacement is ugly,
	but it'll have to do */
/*					ship->xvel= (ship->ix>0 ? Bounce : -Bounce); */
					if(ship->ix > 0)
						ship->xvel= Bounce;
					else
						ship->xvel= -Bounce;
/*					ship->yvel= (ship->iy>0 ? Bounce : -Bounce); */
					if(ship->iy > 0)
						ship->yvel= Bounce;
					else
						ship->yvel= -Bounce;
					wound(ship,FLASHTIME);
					}
				} 
			} 
		} 
	}
do_shoot(ship)
register struct mass *ship;
	{
	register struct mass *newbomb;
	if(ship->u.s.bombcount)
		{
		/* fire a bomb. first find a free bomb slot */

		for(newbomb= b; newbomb->alive; ++newbomb);
			newbomb->u.b.frame= t.bomb;

		/* the velocity factor is to keep ships from blowing
		   their noses off when they shoot retrograde */

		newbomb->scix= 0;
		newbomb->ix= 
			newbomb->x= ship->x + t.bdelp[(ship->theta+64)&255] - ship->xvel;

	/* Same thing for Y */

		newbomb->sciy= 0;
		newbomb->iy= 
			newbomb->y= ship->y + t.bdelp[ship->theta] - ship->yvel;

		newbomb->xvel = ship->xvel +
				  t.bdelv[(ship->theta+64)&255];
		newbomb->yvel = ship->yvel +
				  t.bdelv[ship->theta];
	
	/* Finish making the object */

		newbomb->engineon    = 0;
		newbomb->alive       = 1;
		newbomb->well        = 1;
		newbomb->u.b.radius      = 7;
		newbomb->theta       = 0;
		newbomb->ton         = 1;
		newbomb->clock       = Blifetime;
		newbomb->u.b.owner       = ship-s;
	/* clear the collision sets */
		newbomb->u.b.shipset= 0;
		newbomb->u.s.bombset= 0;

	   /* finally, set the time until the next shot */

		ship->clock= Scooltime;
		--(ship->u.s.bombcount);
		}
	else ++(ship->clock);
	}

do_derelict(ship)
struct mass *ship;
	{
	if(!--(ship->clock))
		{
		ship->well= 1;
		ship->alive=0;
		--live_ships;
		/* it's dead; clear its spot */
		ras_put(ship->scix,  ship->sciy,
		31,          31,
		   (ship->u.s.frame)[ship->theta],
		   GXxor);
		}
	/* Make the ship spin at random */
	else ship->ton += (ship->ix + ship->iy);
	}
