#include <legsdef.h>

/* spin takes a 256 sframe array, looks at the image in frame 0 of it,
	then generates 255 other frames of that image rotated */

/* integer scaling for bit coordinate locating */
#define MOFFSET 22
/* useful macros */

#define rfrom(yin,xin) (rtab[(yin<0? -yin:yin)][(xin<0? -xin:xin)])
#define afrom(yin,xin)\
	((yin<0	?	(xin<0	?	(128+atab[-yin][-xin])\
						:	(256-atab[-yin][xin]))\
			:	(xin<0	?	(128-atab[yin][-xin])\
						:	(atab[yin][xin]))))

#define bit_on(iptr,x,y)\
	*(iptr+((x>0 ? 31:0) + y + 15)) |=\
		(x>0 ? (0x8000 >> (x-1)) : (1 << -x))
#define point(iptr,x,y)\
	*(iptr+((x>0 ? 31:0) + y + 15)) &\
		(short)(x>0 ? (0x8000 >> (x-1)) : (1 << -x))

/* the sine table */
short sintab[256]= {
#include "/usr/bane/graphics/spin/sfile.h"
};
/* the radius table */
unsigned short rtab[16][16]= {
#include "/usr/bane/graphics/spin/rfile.h"
};
/* the angle table */
unsigned char atab[16][16]= {
#include "/usr/bane/graphics/spin/afile.h"
};

/* neighbor count storage */
char neigh[31][31];

spin(spinbuf) register short spinbuf[][62];
	{unsigned short radius;
	unsigned char angle;
	short xmax,ymax;
	register int yin,xin,k,x,y;
	register short *imptr;
	register char *neighptr= (char *) neigh-1;

/* first get the neighborhood count */
    for(yin= -15; yin< 16; yin++)
        {
        for(xin= -15; xin< 16; xin++)
            {
            if(point((short *)spinbuf,xin,yin))
                {
                xmax= (xin==15? 30 : xin+16);
                ymax= (yin==15? 30 : yin+16);
                for(x= (xin == -15? 0 : xin+14); x <= xmax; ++x)
                    for(y= (yin == -15? 0 : yin+14); y <= ymax; ++y)
                        ++neigh[y][x]; /* this looks strange but is right */
                }
            }
        }

/* this code prints the adjacency matrix when left in
    for(yin=30; yin>=0; yin--)
        {
        for(xin=0; xin<31; xin++)
			printf("%1d",neigh[yin][xin]);
	putchar('\n');
		}
*/

/* then generate the spun images */
    for(yin= -15; yin< 16; yin++)
        {
        for(xin= -15; xin< 16; xin++)
            {
			neighptr++;
            if(point((short *)spinbuf,xin,yin))
				{
				radius= rfrom(yin,xin);
				angle= afrom(yin,xin);
				/* will be *(current image) */
				imptr= (short *) spinbuf;
				for(k=1; k<256; k++)
					{
					imptr+= 62;
					y=((radius*sintab[++angle])>>(MOFFSET-1));
					x=((radius*sintab[angle+=64])>>(MOFFSET-1));
					angle -= 64;
				/* rounding of results */
					if(x&1) x+=2;
					if(y&1) y+=2;
					x>>=1; y>>=1;
				/* x and y are coordinates of new dot */
					if(x >= -15 && x <= 15 && y >= -15 && y <= 15)
                        if(*neighptr == 9)
                            {
                            xmax= (x==15? 15 : x+1);
                            ymax= (y==15? 15 : y+1);
                                for((x==-15? 0 : --x); x <= xmax; ++x)
                                    for((y==-15? 0 : --y); y <= ymax; ++y)
					                    bit_on(imptr,x,y);
			                }
			            else
                       		bit_on(imptr,x,y);
			        }
/* these putchars, when left in, plot an inverted image of what the ras_get
	snarfed from the screen */
				/*putchar('X'); */
				}
			/*else putchar(' '); */
			}
		/*putchar('\n'); */
		}
	}
