#include <mon/sunromvec.h>
#include <mon/asyncbuf.h>
#include <sgtty.h>
#include <stdio.h>
#include "udvals.h"	/* equates for the translation table */

/* this helps us get the address constants right */
DEFBUF (updownbuf,unsigned char,90);

/* globals for state memory and a translation table */

struct udkb_ctrl
	{unsigned char	*getptr, *putptr, *endptr, overrun;}
		oldkbc, newkbc;
unsigned char *seekbc,*seekbuf;
int kbdesc,ud_count;
unsigned char trtab[] = {
DREK, DREK, DREK, DREK, DREK, DREK, DREK, DREK,
DREK, DREK, ARUP, ARDN, ARLE, ARRI, DREK,  PF1,
 PF2,  PF3,  PF4,  033,  '1',  '2',  '3',  '4',
 '5',  '6',  '7',  '8',  '9',  '0',  '-',  '=',
 '`',  010, BRAK, PAD7, PAD8, PAD9, PADd, '\t',
 'q',  'w',  'e',  'r',  't',  'y',  'u',  'i',
 'o',  'p',  '[',  ']', DREK, PAD4, PAD5, PAD6,
PADc, CTRL, CPLK,  'a',  's',  'd',  'f',  'g',
 'h',  'j',  'k',  'l',  ';', '\'', '\r', '\\',
PAD1, PAD2, PAD3, CAPS, NOSC,  LSH,  'z',  'x',
 'c',  'v',  'b',  'n',  'm',  ',',  '.',  '/',
 RSH, '\n', PAD0, DREK, PADp, PADe, DREK, DREK,
DREK, DREK,  ' ', DREK, DREK, DREK, DREK, DREK,
DREK, DREK, DREK, DREK, DREK, DREK, DREK, DREK,
DREK, DREK, DREK, DREK, DREK, DREK, DREK, DREK,
DREK, DREK, DREK, DREK, DREK, DREK, DREK, DREK
};
struct sgttyb oldtty, newtty;

ud_init()
	{struct sunromvec mysunrom;
	
	kbdesc= open("/dev/kmem",0);
	lseek(kbdesc,0x200000,0);			/* find the ROM table */
	read(kbdesc,&mysunrom,sizeof mysunrom);		/* slurp it in */
	seekbc= (unsigned char *) mysunrom.v_Keybuf;	/* set global pointer */
	seekbuf= &(((updownbuf *)seekbc)->block[0]);	/* to buffer */
	lseek(kbdesc,seekbc,0);	/* finally, initialize the control blocks */
	read(kbdesc,&newkbc,sizeof newkbc);
	gtty(0,&oldtty);
	newtty= oldtty;
	newtty.sg_flags |= RAW;
	newtty.sg_flags &= ~ECHO;
	stty(0,&newtty);
	ud_count= 0;		/* rashly assume no keys are depressed now */
	}

ud_suspend()	/* temporarily takes us out of raw mode */
	{
	stty(0,&oldtty);
	ioctl(0,TIOCFLUSH,&oldtty);
	/* flush the stdin stream */
	stdin->_ptr = stdin->_base;
	stdin->_cnt= 0;
	}

ud_resume()	/* puts us back in raw mode */
	{
	stty(0,&newtty);
	ud_count= 0;		/* again rashly assume state of keys */
	lseek(kbdesc,seekbc,0);	/* initialize the control blocks again */
	read(kbdesc,&newkbc,sizeof newkbc);
	}

/* ud_count may be incorrect for awhile, but becomes valid after the first
	7f (no keys down) is seen and stays valid thereafter */

ud_quit()	/* cleans up afterwards, put it in signal catcher routines */
	{
	stty(0,&oldtty);
	ioctl(0,TIOCFLUSH,&oldtty);
	/* flush the stdin stream */
	stdin->_ptr = stdin->_base;
	stdin->_cnt= 0;
	close(kbdesc);
	}

ud_read(result) register unsigned char *result;
	{unsigned char udbuf[91];	/* local storage for chars */
	register unsigned char *udptr = udbuf;
	register unsigned char *trindex= trtab;	/* fast referencing */
	register int numchars,localcount;

/* Chris tells me since the keyboard is in raw mode, it will never be
	necessary to flush standard input. I hope he's right... */

/* first suck in the current state */
	oldkbc= newkbc;
	lseek(kbdesc,seekbc,0);
	read(kbdesc,&newkbc,sizeof newkbc);
/* then grab data (if any), translate it and feed it to result */
	if(numchars= newkbc.putptr - oldkbc.putptr)
		{
		lseek(kbdesc,oldkbc.putptr,0);
		if(numchars > 0)
			/* simple case; only one block */
			udptr += read(kbdesc,udptr,numchars);
		else	/* other case; over the end of the block */
			{
/* the if catches the perverse case of the old
pointer pointing off the end of the buffer */
			if(oldkbc.putptr != seekbuf+90)
				{
				udptr += read(kbdesc,udptr,
						seekbuf+90 - oldkbc.putptr);
				}
			lseek(kbdesc,seekbuf,0);
			udptr += read(kbdesc,udptr,newkbc.putptr-seekbuf);
			}
		*udptr= 0;	/* close off the read string */
/* now translate the string,throw away those 7f's, and maintain ud_count */
		for(localcount= ud_count,udptr= udbuf; *udptr; ++udptr)
			{
			if(*udptr > 0x7f)	/* an up key */
				{
				*result++= trindex[*udptr - 0x80] + 0x80;
				--localcount;
				}
			else if (*udptr < 0x7f)	/* a down key */
				{
				*result++= trindex[*udptr];
				++localcount;
				}
			else	localcount= 0;	/* a 7f - no keys down */
			}
		ud_count= localcount;
		}
	*result= 0;	/* in any case, close off the string */
	}
